function toggleVmailVhost(become, action, numv) {
    if (numv == 0)
        return;

    // toggle delete for any vhosts/vmails
    var delete_id;
    var save_id;
    for (var i=1;i<=numv;i++) {
        delete_id = become+i+'_delete';
        save_id = become+i+'_save';
        span_save_id = save_id+'s';
        if (action == 'delete') {
            document.getElementById(delete_id).checked=true;
            document.getElementById(save_id).disabled=true;
            document.getElementById(span_save_id).setAttribute("class", "disabled");
        } else if (action == 'save') {
            document.getElementById(delete_id).checked=false;
            document.getElementById(save_id).checked=false;
            document.getElementById(save_id).disabled=false;
            document.getElementById(span_save_id).setAttribute("class", "");
        }
    }
}

function verify() {
    var ftag = document.getElementsByTagName('fieldset');
    var a = new Array();
    var showerr;
    var save_id;
    var delete_id;

    for (var i=0;i<ftag.length;i++) {
        if (ftag[i].id) {
            showerr = false;
            a = ftag[i].id.split('-');
            save_id = a[0]+'_save';
            delete_id = a[0]+'_delete';

            // was the group account toggled?
            if (! document.getElementById(save_id).checked && ! document.getElementById(delete_id).checked)
               showerr = true;

            // any vhosts/vmails?
            if (a[1] > 0) {
                // were they toggled?
                for (var j=1;j<=a[1];j++) {
                    save_id = a[0]+j+'_save';
                    delete_id = a[0]+j+'_delete';
                    if (! document.getElementById(save_id).checked && ! document.getElementById(delete_id).checked)
                       showerr = true;
                }
            }
            if (showerr) {
               document.getElementById(ftag[i].id+'-error').innerHTML = "<span name='error' class='error'>This information is required</span>";
               document.getElementById(ftag[i].id).setAttribute("class", "webtools_required");
            } else {
               document.getElementById(ftag[i].id+'-error').innerHTML = "";
               document.getElementById(ftag[i].id).setAttribute("class", "webtools");
            }
        }
    }
}

function submitChoices() {
    // verify no name='error' exist on the form
    if (document.getElementsByName('error').length > 0)
        return false;

    var itag = document.getElementsByTagName('input');
    var a = new Array();
    var request = GetXmlHttpObject();

    if (request == null) {
        alert ("Your browser does not support XMLHTTP!");
        return;
    }

    // no loader for add
    var loader_id = null;

    // response data for add
    var data_id = 'showchoices';

    for (var i=0;i<itag.length;i++) {
        if (itag[i].type == 'radio' && itag[i].checked) {
            a.push(itag[i].name+':'+itag[i].value);
        } else if (itag[i].type == 'hidden' && itag[i].name == 'serialized_become_arr') {
            var sba = itag[i].value;
        }
    }

    // serialize the choices before passing to PHP
    var sa_choices = serialize(a);

    // send post request
    sendPostRequest(request, "showresults.php", "choices="+sa_choices+"&sba="+sba, data_id, loader_id);

    // wait 1 sec and remove the div IFF success
    setTimeout("deleteFieldsetsDiv()", 1000);
}

function deleteFieldsetsDiv() {
    // remove the div
    var c = document.getElementById('groupfieldsets');
    c.parentNode.removeChild(c);

    return true;
}

// http://phpjs.org/functions/serialize:508
function serialize (mixed_value) {
    // http://kevin.vanzonneveld.net
    // +   original by: Arpad Ray (mailto:arpad@php.net)
    // +   improved by: Dino
    // +   bugfixed by: Andrej Pavlovic
    // +   bugfixed by: Garagoth
    // +      input by: DtTvB (http://dt.in.th/2008-09-16.string-length-in-bytes.html)
    // +   bugfixed by: Russell Walker (http://www.nbill.co.uk/)
    // +   bugfixed by: Jamie Beck (http://www.terabit.ca/)
    // +      input by: Martin (http://www.erlenwiese.de/)
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net/)
    // +   improved by: Le Torbi (http://www.letorbi.de/)
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net/)
    // +   bugfixed by: Ben (http://benblume.co.uk/)
    // -    depends on: utf8_encode
    // %          note: We feel the main purpose of this function should be to ease the transport of data between php & js
    // %          note: Aiming for PHP-compatibility, we have to translate objects to arrays
    // *     example 1: serialize(['Kevin', 'van', 'Zonneveld']);
    // *     returns 1: 'a:3:{i:0;s:5:"Kevin";i:1;s:3:"van";i:2;s:9:"Zonneveld";}'
    // *     example 2: serialize({firstName: 'Kevin', midName: 'van', surName: 'Zonneveld'});
    // *     returns 2: 'a:3:{s:9:"firstName";s:5:"Kevin";s:7:"midName";s:3:"van";s:7:"surName";s:9:"Zonneveld";}'
    var _utf8Size = function (str) {
        var size = 0,
            i = 0,
            l = str.length,
            code = '';
        for (i = 0; i < l; i++) {
            code = str.charCodeAt(i);
            if (code < 0x0080) {
                size += 1;
            } else if (code < 0x0800) {
                size += 2;
            } else {
                size += 3;
            }
        }
        return size;
    };
    var _getType = function (inp) {
        var type = typeof inp,
            match;
        var key;

        if (type === 'object' && !inp) {
            return 'null';
        }
        if (type === "object") {
            if (!inp.constructor) {
                return 'object';
            }
            var cons = inp.constructor.toString();
            match = cons.match(/(\w+)\(/);
            if (match) {
                cons = match[1].toLowerCase();
            }
            var types = ["boolean", "number", "string", "array"];
            for (key in types) {
                if (cons == types[key]) {
                    type = types[key];
                    break;
                }
            }
        }
        return type;
    };
    var type = _getType(mixed_value);
    var val, ktype = '';

    switch (type) {
    case "function":
        val = "";
        break;
    case "boolean":
        val = "b:" + (mixed_value ? "1" : "0");
        break;
    case "number":
        val = (Math.round(mixed_value) == mixed_value ? "i" : "d") + ":" + mixed_value;
        break;
    case "string":
        val = "s:" + _utf8Size(mixed_value) + ":\"" + mixed_value + "\"";
        break;
    case "array":
    case "object":
        val = "a";
/*
            if (type == "object") {
                var objname = mixed_value.constructor.toString().match(/(\w+)\(\)/);
                if (objname == undefined) {
                    return;
                }
                objname[1] = this.serialize(objname[1]);
                val = "O" + objname[1].substring(1, objname[1].length - 1);
            }
            */
        var count = 0;
        var vals = "";
        var okey;
        var key;
        for (key in mixed_value) {
            if (mixed_value.hasOwnProperty(key)) {
                ktype = _getType(mixed_value[key]);
                if (ktype === "function") {
                    continue;
                }

                okey = (key.match(/^[0-9]+$/) ? parseInt(key, 10) : key);
                vals += this.serialize(okey) + this.serialize(mixed_value[key]);
                count++;
            }
        }
        val += ":" + count + ":{" + vals + "}";
        break;
    case "undefined":
        // Fall-through
    default:
        // if the JS object has a property which contains a null value, the string cannot be unserialized by PHP
        val = "N";
        break;
    }
    if (type !== "object" && type !== "array") {
        val += ";";
    }
    return val;
}

// http://phpjs.org/functions/utf8_encode:577
function utf8_encode (argString) {
    // http://kevin.vanzonneveld.net
    // +   original by: Webtoolkit.info (http://www.webtoolkit.info/)
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: sowberry
    // +    tweaked by: Jack
    // +   bugfixed by: Onno Marsman
    // +   improved by: Yves Sucaet
    // +   bugfixed by: Onno Marsman
    // +   bugfixed by: Ulrich
    // +   bugfixed by: Rafal Kukawski
    // *     example 1: utf8_encode('Kevin van Zonneveld');
    // *     returns 1: 'Kevin van Zonneveld'

    if (argString === null || typeof argString === "undefined") {
        return "";
    }

    var string = (argString + ''); // .replace(/\r\n/g, "\n").replace(/\r/g, "\n");
    var utftext = "",
        start, end, stringl = 0;

    start = end = 0;
    stringl = string.length;
    for (var n = 0; n < stringl; n++) {
        var c1 = string.charCodeAt(n);
        var enc = null;

        if (c1 < 128) {
            end++;
        } else if (c1 > 127 && c1 < 2048) {
            enc = String.fromCharCode((c1 >> 6) | 192) + String.fromCharCode((c1 & 63) | 128);
        } else {
            enc = String.fromCharCode((c1 >> 12) | 224) + String.fromCharCode(((c1 >> 6) & 63) | 128) + String.fromCharCode((c1 & 63) | 128);
        }
        if (enc !== null) {
            if (end > start) {
                utftext += string.slice(start, end);
            }
            utftext += enc;
            start = end = n + 1;
        }
    }

    if (end > start) {
        utftext += string.slice(start, stringl);
    }

    return utftext;
}
